#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define MAX_SIZE 100

int IntCmp(const void* pInt1, const void* pInt2);
void PrintArray(const int a[], int size);
int ReadBinArray(const char* pFilename, int a[], int size);
int WriteBinArray(const char* pFilename, const int a[], int size);

int main(void)
{
	int a[MAX_SIZE];
	int count;
	
	count = ReadBinArray("numbers.bin", a, MAX_SIZE);
	if (count > 0)
	{
		PrintArray(a, count);
		qsort(a, count, sizeof(int), IntCmp);
		PrintArray(a, count);
		WriteBinArray("sorted.bin", a, count);
	}

	return 0;
}

/* ƷʽpFilenameļڶsize浽aУʵʶĸ */
int ReadBinArray(const char* pFilename, int a[], int size)
{
	FILE* fp;
	int count=0;
	
	assert(pFilename != NULL);
	
	fp = fopen(pFilename, "rb");
	if (fp == NULL)
	{
		perror(pFilename);
	}
	else
	{
		count = fread(a, sizeof(a[0]), size, fp);
	}

	if (fp != NULL)
		fclose(fp);
	return count;
}

/* ƷʽpFilenameļдaеsizeԪأʵдĸ 
 * pFilenameļڣ */
int WriteBinArray(const char* pFilename, const int a[], int size)
{
	FILE* fp;
	int count=0;
	
	assert(pFilename != NULL);
	
	fp = fopen(pFilename, "wb");
	if (fp == NULL)
	{
		perror(pFilename);
	}
	else
	{
		count = fwrite(a, sizeof(a[0]), size, fp);
	  	if (count < size)
	  	{
	  		perror(pFilename);
	  	}
	}

	if (fp != NULL)
		fclose(fp);
	return count;
}

/* ӡaԪ */
void PrintArray(const int a[], int size)
{
	int i;
	
	for (i=0; i<size; i++)
		printf("%4d", a[i]);
	putchar('\n');
}

/* qsortĻصȽint */
int IntCmp(const void* pInt1, const void* pInt2)
{
	const int *p1, *p2;
	
	assert(pInt1 != NULL && pInt2 != NULL);
	
	p1 = (const int*)pInt1;
	p2 = (const int*)pInt2;
	
	if (*p1 < *p2)
		return -1;
	else 
		return (*p1 != *p2);

/*	
	if (*p1 < *p2)
		return -1;
	else if (*p1 > *p2)
		return 1;
	else 
		return 0;
*/
}
