#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define MAX_SIZE 100

int IntCmp(const void* pInt1, const void* pInt2);
void PrintArray(const int a[], int size);
int ReadTextArray(const char* pFilename, int a[], int size);
int WriteTextArray(const char* pFilename, const int a[], int size);

int main(void)
{
	int a[MAX_SIZE];
	int count;
	
	count = ReadTextArray("numbers.txt", a, MAX_SIZE);
	if (count > 0)
	{
		PrintArray(a, count);
		qsort(a, count, sizeof(int), IntCmp);
		PrintArray(a, count);
		WriteTextArray("sorted.txt", a, count);
	}

	return 0;
}

/* ıʽpFilenameļڶsize浽aУʵʶĸ */
int ReadTextArray(const char* pFilename, int a[], int size)
{
	FILE* fp;
	int count=0;
	
	assert(pFilename != NULL);
	
	fp = fopen(pFilename, "r");
	if (fp == NULL)
	{
		perror(pFilename);
	}
	else
	{
		for (count=0; count<size; count++)
		{
		  	if (fscanf(fp, "%d", &a[count]) != 1)
		  		break;
		}
	}

	if (fp != NULL)
		fclose(fp);
	return count;
}

/* ıʽpFilenameļдaеsizeԪأʵдĸ 
 * pFilenameļڣ */
int WriteTextArray(const char* pFilename, const int a[], int size)
{
	FILE* fp;
	int count=0;
	
	assert(pFilename != NULL);
	
	fp = fopen(pFilename, "w");
	if (fp == NULL)
	{
		perror(pFilename);
	}
	else
	{
		for (count=0; count<size; count++)
		{
		  	if (fprintf(fp, "%4d", a[count]) < 0)
		  	{
		  		perror(pFilename);
		  		break;
		  	}
		}
	}

	if (fp != NULL)
		fclose(fp);
	return count;
}

/* ӡaԪ */
void PrintArray(const int a[], int size)
{
	int i;
	
	for (i=0; i<size; i++)
		printf("%4d", a[i]);
	putchar('\n');
}

/* qsortĻصȽint */
int IntCmp(const void* pInt1, const void* pInt2)
{
	const int *p1, *p2;
	
	assert(pInt1 != NULL && pInt2 != NULL);
	
	p1 = (const int*)pInt1;
	p2 = (const int*)pInt2;
	
	if (*p1 < *p2)
		return -1;
	else 
		return (*p1 != *p2);

/*	
	if (*p1 < *p2)
		return -1;
	else if (*p1 > *p2)
		return 1;
	else 
		return 0;
*/
}
